.setcpu     "65816"
.autoimport on
.include "inc/common-macros.inc"
.include "inc/GlobalVars.inc"
.include "inc/ports.inc"


.import MONSACT00_00_ADDR:far
.import MONSACT00_00_DATA:far




; Cartridge metadata - - -
.segment "CARTINFO"
	;        123456789012345678901
	.byte	"MODE7TEST            "	; Game Title(21Bytes)
	.byte	$00				; 0x01:HiRom, 0x30:FastRom(3.57MHz)
	.byte	$00				; ROM only
	.byte	$09				; 512KB ROM
	.byte	$00				; RAM Size (8KByte * N)
	.byte	$00				; NTSC
	.byte	$01				; Licensee
	.byte	$00				; Version

	; Embed information (must be replaced with checksum)
	.word   $CDCD
	.word   $3232

	.byte	$ff, $ff, $ff, $ff		; unknown

	.word	$0000       ; Native:COP
	.word	$0000       ; Native:BRK
	.word	$0000       ; Native:ABORT
	.word	VBlank		; Native:NMI
	.word	$0000		; 
	.word	$0000       ; Native:IRQ

	.word	$0000       ; 
	.word	$0000       ; 

	.word	$0000       ; Emulation:COP
	.word	$0000       ; 
	.word	$0000       ; Emulation:ABORT
	.word	$0000       ; Emulation:NMI
	.word	Reset       ; Emulation:RESET
	.word	$0000       ; Emulation:IRQ/BRK







.segment "STARTUP"
; Reset int. (Entry Point) -------------------
.proc Reset ; int handler
	; *unsafe* X
	; vvv Bootstrap -----------------
	sei ; Disable int.
	clc ; C=0
	xce ; C<->E Native Mode On

	phk
	plb ; PB -stack-> DB (=0)

	rep #$30 ; A,I 16bit
	.a16
	.i16

	; Initialize stack
	ldx #$1fff
	txs
	
	jsr initRegs
	; ^^^ Bootstrap -----------------

	stz gRenderFinished
	jsr sceneInit
	jsr doMainLoop

	rti
.endproc

; --------------------------------------------
; A16, I16

;fobOp
.export		doMainLoop

.proc doMainLoop
.a16		; 16 bit Iyh
.i16		; X/y  16bit ɂ떽
	save_paxy


.if 0
	; eXg
	lda #$1234
	set_a8
	xba
	nop

	set_a16
	lda #$1234
	xba
	nop
.endif

	stz gRenderFinished

	r_wait_VBlank:
	lda gRenderFinished
	beq r_wait_VBlank
				
	; VRAMAhX͍ŏ
	lda #$6000
	sta pVWriteAddrW





	; VRAMݑÕEFCg
	stz MAP_LOADEXTROM_NEXTDATAPOS
	lda #8
	sta MAP_LOADEXTROM_DATASIZE
	.a8
	set_a8
	lda #0
	sta MAP_LOADEXTROM_DATAS
	lda #2
	sta MAP_LOADEXTROM_DATAS+1
	lda #4
	sta MAP_LOADEXTROM_DATAS+2
	lda #6
	sta MAP_LOADEXTROM_DATAS+3
	lda #8
	sta MAP_LOADEXTROM_DATAS+4
	lda #10
	sta MAP_LOADEXTROM_DATAS+5
	lda #12
	sta MAP_LOADEXTROM_DATAS+6
	lda #14
	sta MAP_LOADEXTROM_DATAS+7

	.a16
	set_a16
	cli
	lda #$4
	sta $b0

	stz MAP_SDMA_LAST_HCOUNTER

	.a8
	set_a8
	; o̓|[g̐MςāAVCounter,HCounter 
	;  2137 ǂݍ񂾎ǂ߂悤ɂƂB
	lda #$80
	sta $4201
	;set_a16


	test_loop:
	.a8
	set_a8					; 3


	; Ƀ|[gIɂ
	.a8
	lda #$80				; 4
	sta $4201				; 4
	;set_a16


	lda $2137				; 4

	; VCounter ǂݍNMI荞݂߂
	; Ƃ肠EFCg
	lda $213f				; 4
	lda $213d				; 4
	xba						; 3
	lda $213d				; 4
	xba						; 3
	set_a16					; 3
	.a16					;     HiClock[hgȂƁB
	and #$01ff				; 3   v31  @HCounter 83(0x53)``94(0x5e)

	cmp #224-180
	bmi void_waitvblanknear
	;Ƃ肠̃R[hł̓[vő҂
	lda #280		; 223JE^VCounter+28
					; 240JE^VCounter+43
	Wait_VBlankNear:
	wait_divcycles
	dec a
	bne Wait_VBlankNear
	
	.a8

	set_a8					; 3
	lda $2137				; 4
	lda $213f				; 4
	lda $213d				; 4
	xba						; 3
	lda $213d				; 4
	xba						; 3
	set_a16					; 3
	.a16					;     HiClock[hgȂƁB
	and #$01ff				; 3   v34  @HCounter 83(0x53)``94(0x5e)


	void_waitvblanknear:


	;test_counterread_count:
	TryRead_HCouunter:
	set_a8					; 3
	lda $2137				; 4

	; HCounter ǂݍ
	lda $213f				; 4
	lda $213c				; 4
	xba						; 3
	lda $213c				; 4
	xba						; 3
	set_a16					; 3
	.a16					;     HiClock[hgȂƁB
	and #$01ff				; 3   v31  @HCounter 83(0x53)``94(0x5e)
							;			 ATCNx2.67{炢B
							;     v 34 ŌvZ 84/  34 = 2.47
	;set_a8					; 3
	;bra test_counterread_count ; 3			

	pha						; 3
	set_a8					; 3

	; HCounter ǂݍ
	lda $2137				; 4
	lda $213f				; 4
	lda $213c				; 4
	xba						; 3
	lda $213c				; 4
	xba						; 3
	set_a16					; 3
	.a16					;     HiClock[hgȂƁB
	and #$01ff				; 3   v28    31cycle HCounter 83(0x53)``94(0x5e)

	; オ肵AʃoCgJE^[
	; ǂ߂Ȃ΍
	; 2ǂŌオ肵Ăǂݒ
	cmp #$100				; 3
	bpl HCounter2_Check		; 2 + 1 if branched

	tax						; 2
	pla						; 3
	txa						; 2

	pha						; 3	cycle
	pla						; 4 cycle
	nop						; 2 cycle

	bra HCounterLatch_Ok	; 3
	
	HCounter2_Check:
	tax						; 2
	lda 0,S					; 5
	cmp #$100				; 3
	bpl HCounter3_Reload
	; 1 <0x100
	; 2 <0x100
	pla						; 3
	tyx						; 2
	
	bra HCounter2_Latch_Ok	; 2 + 1 if branched
	
	
		HCounter3_Reload:
		; 2ǂݍ񂾂ǂ̒lMpłȂ̂
		; jēǂݒ
		pla						; 4

		; HCounter ǂݍ
		set_a8					; 3
		.a8
		lda $2137				; 4
		lda $213f				; 4
		lda $213c				; 4
		xba						; 3
		lda $213c				; 4
		xba						; 3
		set_a16					; 3
		.a16					; 
		and #$01ff				; 3   v31  @HCounter 83(0x53)``94(0x5e)

		pha				; 3	cycle
		pla				; 4 cycle
		xba				; 3 cycle
		xba				; 3 cycle
		xba				; 3 cycle
		xba				; 3 cycle
		nop				; 2 cycle	v 21		v 52

	HCounterLatch_Ok:					; HCounter ǂݍ݂炱܂52
	HCounter2_Latch_Ok:					; HCounter ǂݍ݂炱܂52


	; Ƀ|[gItɂ
	tax						; 2  HCounterޔ
	.a8
	set_a8					; 3
	; o̓|[g̐MςāAVCounter,HCounter 
	;  2137 ǂݍ񂾎ǂ߂悤ɂƂB
	lda #$00				; 4
	sta $4201				; 4
	;set_a16
	.a16
	set_a16					; 3
	txa						; 2   v 18

	; sTCN2.2{AHCOUNTER lɂȂHHH
	; 
	; KvȃEFCg
	;
	;        ǂݎ
	;        HCounter
	;           |
	;           |  HCounter
	;           |œǂݎ肵
	;           |+
	;           |[vJE^
	;           |쐬+
	;           |ރf[^
	;           |쐬鏈
	;           |    |
	;           |    |      [v
	;           |    |      }
	;           |    |       EFCg
	;   0       |<---+---->|<--------->273         339(0x153)
	;   |       |          |            |  66JE^  |
	;   |-------|----------|------------|------------- |
	
	; (273 - HCounter) = (2+3) x2.2 x [v  + cycle x 2.2 

	; (273 - hcounter - )/( 5*2.2) KvȃEFCgB


	; }CiXlɕύX
	eor #$ffff				; 3
	add #1					; 2+3
	
	adc #(273-553+   339 + 11+0)	; 3
							; 		454:
							;			  HJE^ǂݎ̏      52        = 52 cycle
							;			  [vJE^쐬         19+45+9   = 73 cycle
							;			  ރf[^쐬鎞   32+50     = 82 cycle
							;		(52+73+82)*2.67 = 552.69
							;			 2.67 ͎
							;       339 : }CiX傫̂HCounter 2MAXƂB
							;		11:269A傢ȂɂȂ̂œK11BZ
							;		]蕪AJE^s鎖Ԃׂ11ӂ𑫂Ă
							;		30:VRAM݂Ȃ񂩓Ȃ̂őČ

	bmi AddedHMax			; 2 branched +1
	and #$ffff				; 3 cycle
	bra NoAddHMaxEnd		; 3
	
	AddedHMax:
	adc #339				; 3 HCounter͍ől360Ȃ̂ł́H
	nop						; 2
	NoAddHMax:				; 򏬌v 8

	NoAddHMaxEnd:			; 򏬌v 8


								;	 v 19

	; 2.68Ŋ鏈
	; 191-0`339+338

	set_a8					; 3
	.a8
	sta pDivc_dividend		; 4
	xba						; 3
	sta pDivc_dividend+1	; 4
	lda #13					; 2
	sta pDivc_divisor		; 4

	wait_divcycles			; 16
	lda #0					; 2
	xba						; 3
	lda pDivc_outQ			; 4	v 45
	
	bne loopwait_exec		; 2 +1 IfBranched( v48cycle)
	nop						; 2
	nop						; 2
	bra loopwait_none		; 3
	
	
	loopwait_exec:
	; _ȉ13.35̃[vJE^␳
	; 20ȏゾ -1 
	tax						; 2
	lda VRamWait_LoopCounerCasts, x	; 4
							;  ̃u`ƍ킹ĕ򏬌v   9


	; JE^[v
	loop_waithblank:
	dec a					; 2 cycle
	bne loop_waithblank		; 3 cycle


	loopwait_none:			; 򏬌v 9(򂵂Ȃ)

	; VRAM ݏ
	.a16
	set_a16								; 3
	lda MAP_LOADEXTROM_DATASIZE			; 5
	sub MAP_LOADEXTROM_NEXTDATAPOS		; 2+5
	asl									; 2
	tax									; 2
	lda VWrite_RestByte_CompareTables, x	; 5
	tax									; 2
	jmp (VWrite_123Byte_Pointers,x)		; 6		v 32



	VWrite_1byte:
	ldy MAP_LOADEXTROM_NEXTDATAPOS		; 5
	set_a8								; 3
	lda MAP_LOADEXTROM_DATAS,y			; 4
	set_a16								; 3
	.a16
	tax									; 2		v 17
	
	pha									; 4
	pla									; 5
	wait_divcycles						; 16
	nop									; 2
	nop									; 2
	nop									; 2
	nop									; 2    v 33    v 50


	sta pVWriteValW
	
	inc MAP_LOADEXTROM_NEXTDATAPOS
	bra VWrote


	VWrite_2byte:
	ldy MAP_LOADEXTROM_NEXTDATAPOS		; 5
	lda #0								; 3
	set_a8								; 3
	lda MAP_LOADEXTROM_DATAS,y			; 4
	tax									; 2		v 17
	
	iny									; 2
	lda MAP_LOADEXTROM_DATAS,y			; 4
	set_a16								; 3		v  9  
	.a16
	
	wait_divcycles						; 16
	nop									; 2
	nop									; 2
	nop									; 2
	nop									; 2    v 24    v 50
	
	
	stx pVWriteValW
	sta pVWriteValW
	
	inc MAP_LOADEXTROM_NEXTDATAPOS
	bra VWrote	
	
	
	
	VWrite_3byte:
	lda MAP_LOADEXTROM_NEXTDATAPOS		; 5
	tay									; 2
	lda #0								; 3
	set_a8								; 3
	lda MAP_LOADEXTROM_DATAS,y			; 4
	tax									; 2
	phx									; 3 (x==0̂Ƃ+1?Ȃ̂)   
										; v22

	iny									; 2
	lda MAP_LOADEXTROM_DATAS,y			; 4
	tax									; 2
	phx									; 3 (x==0̂Ƃ+1?Ȃ̂)
										; v11
	
	iny									; 2
	lda MAP_LOADEXTROM_DATAS,y			; 4   
	ply									;4  (y==0̂Ƃ+1?Ȃ̂)
	plx									;4  (x==0̂Ƃ+1?Ȃ̂)
										; v14
	
	.a16
	set_a16								; 3
		
										; v 3    v  50





	;nop
	;nop
	;nop
	;nop
	;nop
	;nop
	;nop

	stx pVWriteValW						; 4+1?
	sty pVWriteValW						; 4+1?
	sta pVWriteValW						; 5

.if 0




	lda MAP_LOADEXTROM_NEXTDATAPOS		;5
	add #3								;2+3
	sta MAP_LOADEXTROM_NEXTDATAPOS		;5

	;inc MAP_LOADEXTROM_NEXTDATAPOS			; 6
	;inc MAP_LOADEXTROM_NEXTDATAPOS			; 6
	;inc MAP_LOADEXTROM_NEXTDATAPOS			; 6
	
	;bra VWrote

.endif


	VWrote:


	; Ƀ|[gIɂ
	.a8
	set_a8					; 3
	; o̓|[g̐MςāAVCounter,HCounter 
	;  2137 ǂݍ񂾎ǂ߂悤ɂƂB
	lda #$80				; 4
	sta $4201				; 4
	lda $2137


	.a8
	;set_a8
	
	;lda $2137

	; HBlankAHCounterx73 JE^ĝŁB
	

	; HCounter ǂݍ
	lda $213f				; 4
	lda $213c				; 4
	xba						; 3
	lda $213c				; 4
	xba						; 3
	set_a16					; 3
	.a16
	and #$01ff				; 3   v30  @HCounter 65`78?

	; AhX͂815c?

	; R[hϒ̒ɂ
	;lda $b0
	lda #40
	tay
	:
	dey
	bne :-

	inc $b0
	lda $b0
	cmp #100
	bpl end_loop
	;bra end_loop

	stz MAP_LOADEXTROM_NEXTDATAPOS
	lda MAP_LOADEXTROM_NEXTDATAPOS
	cmp MAP_LOADEXTROM_DATASIZE
	bmi NotEditPos
	stz MAP_LOADEXTROM_NEXTDATAPOS
	NotEditPos:

	
	brl test_loop

	end_loop:
	bra end_loop

	VRamWait_LoopCounerCasts:
	.byte 0,1+1,2+1,3+1,4+1,5+1,6+1,7+1,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30


	VWrite_RestByte_CompareTables:
		;   X  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f 10
	.word	0, 0, 2, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4

	VWrite_123Byte_Pointers:
	.word VWrite_1byte, VWrite_2byte, VWrite_3byte




	stz MAP_FIELD_NO
	lda #10
	sta MAP_FIELD_GROBALX
	sta MAP_FIELD_GROBALY

	jsr MapLoad


	mloop:




		jsr updateScene
		stz gRenderFinished

		;nop
		;bra mloop
		;nop


		r_wait:
			;inc gGlobalCount2
			


			; ]ʂOɂȂI
			lda gMONS_0_CNT
			bne :+
			brl r_wait_2
			

			:

			; HDMA VRAM ݂̃R[h
			lda gMONS_0_READY
			bne TO_WAIT_HBLANK
			bra DP_SET

TO_WAIT_HBLANK:
			BRL		WAIT_HBLANK

			; f[^oNWX^A
			;f[^|C^WX^ݒ
			DP_SET:

			;set_a8
			;.a8
			;lda #.LOBYTE(.HIWORD(gHDMATable_TrC))
			lda		#.LOBYTE(.HIWORD(MONSACT00_00_ADDR))
			
			; ŃoNWX^Ȃ񂩐ݒ肵Ă񂾂H
			pha
			plb
			lda gSDMA_TBLADDR
			tcd

.if 0
			; Ȃꉞ͂
			; a5 .....AZuǂĔfĂ񂾁H
			; ȂAꉞ͓ǂ߂邗
			; ǁABANK=0 ŁA008761 QƂĂ邩A
			; {ȂROM ǂ܂ȂႢȂ̂
			; ROM ȊOQƂĂ͖̂Ȃ̂H
			; lda dp   a5 XXɃAZu悭񂯂ǂ
			lda		$0
			lda		$2
			lda		$4
			lda		$6
.endif

			ldx		gMONS_0_POS
			; x8bit܂łLłȂnYȂ̂ɁA
			; Ȃ16bit offset ƂēĂcB
			; ̂낤B
			lda		z:$4,x
			sta		gSDMA_ADDR2
			lda		z:$6,x
			sta		gSDMA_DATA2

			lda		z:$2,x
			tay

			lda		z:$0,x
			tax



			lda		#$0
			tcd
.if 0
			tcd
			lda f:MONSACT00_00_ADDR,x		; BF rr rr rr    al,x 
			lda MONSACT00_00_ADDR,x		; 

			; ȉ͂ȂAZuʂB
			;lda (d),y         d͊OV{
			;lda [d],y
			;lda d,y
			;lda [$55],y
			;lda ($55,x)    a1 55       

			;lda ($55),y			 b1 55  (d),y   Direct indirect indexed
			;						 DP 𑫂 DBR͑ȂH

			

			sta gSDMA_ADDR2

			pla
			add #$2
			tax
			lda f:MONSACT00_00_ADDR,x
			sta gSDMA_DATA2
			
			
			lda f:gMONS_0_POS

			tax
			lda f:MONSACT00_00_ADDR,x
			tax
			
			
			lda f:gMONS_0_POS
			incinc
			tay
			lda f:MONSACT00_00_ADDR,y
			tay

.endif

			; ܂łŁA
			;  X:              0_ADDR+offset
			;  Y:              0_ADDR+offset+2
			; gSDMA_ADDR2 :    0_ADDR+offset+4
			; gSDMA_DATA2 :    0_ADDR+offset+6
			; oĂ͂EEEԂEEEEB

			inc gMONS_0_READY
			bra r_wait_2

		WAIT_HBLANK:


			lda		gIGNORE_VHCOUNTER_CNT
			beq		CheckVCounter
			
			dec		gIGNORE_VHCOUNTER_CNT
			bra 	r_wait_2

.if 0
			; cÃR[h񔤂Ȃ񂾂ǁcB
			; ꉞĂB

			; Ȃ񂩒m񂯂ǃAvP[VG[
			; G~[^Ă܂̂
			; W񂾂ނ悤ɂĂ݂B
			lda 	gGlobalCount2
			and		#$0f
			bne		r_wait_2
.endif

		CheckVCounter:
			.a8
			set_a8
			lda #$80
			sta $4201
			lda #$00
			sta $4201
			
			.a16
			set_a16

			; VCounter ǂݍ
			; VBLANKt߂
			; ȂB
			; 悤ƂāAautojoypadƂԂ
			; ̂|̂Łc
			; ĂZ 127uŝ
			; Ȃ߂Ȃ񂾂ǁcB
			lda $213d
			and #$01ff
			cmp		#224
			bcs		CheckHCounter
			; 128 [v炢͓KɖB
			lda		#$10
			sta		gIGNORE_VHCOUNTER_CNT

			bra		r_wait_2

	CheckHCounter:

			lda $213c
			and #$01ff
			; HCounter  H=274HBLANKԂɓB
			; Aۂɂ́AuVRAMݎn߂ď݂
			; I܂ł̖ߎsԁv~̂ŁA
			; ̏ԂcĂ邩vZKvB
			; HDMA {ғ邩ɂĉғԂ
			; ܂ňė̂łȂV[vAJ
			; vZĂKv͂H
			
			; HCounter > 274-x ? Ȃ珑݁B
			; cmp		#(274-x)
			;		x: VRAM݂܂łɎss
			;		   1߂̎smastercycle5ƂČvZB
			;			
			;cmp	#(274-3)		; 5?12?   
			; ȉA10 ƁuEӂƂv̏B
			;cmp		#(274+10)		; 5?12?   
			; 15,18,25,30 Yɂł邗
			; PɃR[fBOxŊԈĂ邾̋CB
			cmp		#(274+15)		; 5?12?   
			bcc 	r_wait_2		; 5?12?

			; HCounter < 339-x-y ? Ȃ珑݁B
			;		x:VRAMs܂ł̎ԁB
			;			15masterclock?12mastercock?
			;			߂ɂƂ12*2=24 master clock
			;			24 msterclock / 8(MasterClock/Hcounter) = 3
			;		y: VRAM ݎs`I܂ł̎s
			;				܂Ƃ6߁A Max 72 master cycle Ȃ̂
			;				y=72/8= 9 count

			;		
			;cmp	#(339-3-9)		; 5?12?
			cmp		#(339-3-9-10)	; 5?12?
			bcc 	r_wait_2		; 5?12?

			; indirect ߂ňĂ邵˂Ȃ
			; ꂪɗpӂꂽu㩁vƁcB
			; HDMA ȂDMAg΂悤ȁcB
			; indrect DMA ĂH
			;stx		pVWriteAddrW
			;sty		pVWriteValW
			
			
			stx		pVWriteAddrW		; 5 , 12
			sty		pVWriteValW			; 5 , 12

			lda		gSDMA_ADDR2			; 5 , 12
			sta		pVWriteAddrW		; 5 , 12
			lda		gSDMA_DATA2			; 5 , 12
			sta		pVWriteValW			; 5 , 12
										; v 30, 72 cycle
			
			; ܁AHvƂႱȂ񂾂낤B
			; ȏ͂ǂMJ񂵂Ă
			; ZoȂ낤cB
			; push/pop ̕ǂ܂B

			; WRIO D8  1>0 ɂV/HCounterb`

.if 0
			; HBLANK ́c܂낤ǂB
			lda $4212
			and #$40
			beq r_wait_2
.endif

			dec		gMONS_0_CNT
			; 8 
			lda		gMONS_0_POS
			add		#$8
			sta		gMONS_0_POS
	
			stz		gMONS_0_READY

.if 0
			;lda		dp,x				; 8
			;sta		pVWriteAddrW		; 5
			;inxinx						; 2, 2
			;lda		dp,x				; 8
			;sta		pVWriteValW			; 5
			;inxinx						; 2, 2   
										; v34 cycle
			; EEE9.69us łEEE
			; Ȃ񂩌vZԈĂ܂񂩁H
			
			;lda		dp,x				; 8
			;sta		pVWriteAddrW		; 5
			;inxinx						; 2, 2
			;lda		dp,x
			;sta		pVWriteValW
			
			; 1 machine cycle = 6 master clock = 6 *47.5ns
			; 34 machine cycle ƁA
.endif



		r_wait_2:

			lda gRenderFinished
			bne :+ 
			brl r_wait

	:
	brl mloop
	
	restore_paxy
	rts
.endproc


; --------------------------------------------
.proc VBlank ; int handler
	php ; 荞ݑOPۑ
set_a16 ; ۑPHAƕAPLAA16œ
.a16
.i16
	pha ; A16bitŕۑ


	;pla ; A16bitŕA
	;plp ; 荞ݑOP𕜋A
	;rti


	;phd
	;lda #0
	;pha
	;pld

	JML (VBLANK_POINTER)
	; Absolute Indirect
	;   00:16bit ԒnɏĂAhXɔԁB
	;   JML߂Ȃ炳ɑOoCgPCBǂݍ
.endproc




; --------------------------------------------
.proc initRegs
	sep	#$20	; A 8bit
.a8
	lda	#$8f
	sta	$2100
	stz	$2101
	
	stz	$2102
	stz	$2103
	stz	$2105
	stz	$2106
	stz	$2107
	stz	$2108
	stz	$2109
	stz	$210a
	stz	$210b
	stz	$210c

	stz	$210d
	stz	$210d
	stz	$210e
	stz	$210e
	stz	$210f
	stz	$210f
	stz	$2110
	stz	$2110
	stz	$2111
	stz	$2111
	stz	$2112
	stz	$2112
	stz	$2113
	stz	$2113
	stz	$2114
	stz	$2114

	lda	#$80
	sta	$2115
	stz	$2116
	stz	$2117
	stz	$211a

	stz	$211b
	lda	#$01
	sta	$211b
	stz	$211c
	stz	$211c
	stz	$211d
	stz	$211d
	stz	$211e
	stz	$211e
	stz	$211f
	stz	$211f
	stz	$2120
	stz	$2120

	stz	$2121
	stz	$2123
	stz	$2124
	stz	$2125
	stz	$2126
	stz	$2127
	stz	$2128
	stz	$2129
	stz	$212a
	stz	$212b
	lda	#$01
	sta	$212c
	stz	$212d
	stz	$212e
	stz	$212f
	lda	#$30
	sta	$2130
	stz	$2131
	lda	#$e0
	sta	$2132
	stz	$2133

	stz	$4200
	lda	#$ff
	sta	$4201
	stz	$4202
	stz	$4203
	stz	$4204
	stz	$4205
	stz	$4206
	stz	$4207
	stz	$4208
	stz	$4209
	stz	$420a
	stz	$420b
	stz	$420c
	stz	$420d

	lda $4210

	rep	#$20
.a16

	rts
.endproc









; ===================================================
; Metadata and Assets
; ===================================================




; DATA SEGMENTS --------------------------------------------------------
.export PaletteBase:far
.export Palette_Field1:far

.export Field1ChrData:far
.export Field1MapData:far

; - - - - - - - - - - - -
; ROMf[^ 摜n_1
.segment "VISASSET1":far
;MonsChrData:
;.include "src/mons.asm"


;TestDWordData:
;	.dword $01234567
	;.word $8080

Field1ChrData:
.include "src/bmpasm/field1.asm"

Field1MapData:
.include "src/bmpasm/map_start.asm"


.segment "VISASSET2": far

	;.word $8181


.segment "VISASSET3": far
PaletteBase:
;.include "src/mons_Color.asm"
Palette_Field1:
.include "src/bmpasm/field1_Color.asm"



.segment "VISASSET4": far

.segment "VISASSET5": far

.segment "MISCASSET": far

.segment "HIRODATA4": far

.segment "HIRODATA5": far

.segment "HIRODATA6": far

.segment "ALTSNDS1": far

.segment "DONTUSE"
	.byte "NO-DATA"

